//
// FILE: proccount.cpp
//
// Copyright (c) 1997 by Aaron Michael Cohen and Mike Woodring
//
/////////////////////////////////////////////////////////////////////////

#include <windows.h>
#define EXPORT_PROCCOUNTAPI
#include "proccount.h"

#pragma data_seg(".Shared")

// Count of processes that have mapped proccount.dll into
// their address space.
//
PROCCOUNTAPI LONG  glAttachedProcessCount = 0;

#pragma data_seg()

// Exported function that will return glAttachedProcessCount.
//
PROCCOUNTAPI LONG WINAPI GetAttachedProcessCount( void )
{
    return(glAttachedProcessCount);
}

// DLL Entry Point
//
BOOL WINAPI DllMain
(
    HANDLE  hInst, 
    ULONG   dwReason,
    LPVOID  lpReserved
)
{
    switch( dwReason )
    {
        case DLL_PROCESS_ATTACH:
            InterlockedIncrement(&glAttachedProcessCount);
        break;

        case DLL_PROCESS_DETACH:
            InterlockedDecrement(&glAttachedProcessCount);
        break;
    }

    return(TRUE);
}
